# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_attr.ipynb.

# %% auto 0
__all__ = ['getshape', 'getdf', 'getcols', 'getcolumns', 'getidx', 'getindex', 'getloc', 'getiloc', 'geticat', 'getds', 'getdfds',
           'getkernel', 'getkdegree', 'getaffinity', 'getdiffop', 'getdata', 'getgraph', 'getclusters', 'getembedding',
           'getcentroids', 'getdiffpot']

# %% ../nbs/10_attr.ipynb 4
from typing import TypeGuard
from typing import Callable

# %% ../nbs/10_attr.ipynb 5
from itry import PHATE
from nlit import (
    KERNEL, KERNEL_DEGREE, AFFINITY, DIFF_OP,  GRAPH, CLUSTERS, EMBEDDING,
    CENTROIDS, DIFF_POTENTIAL, CENTROIDS, DIFF_OP, AFFINITY, CLUSTERS, GRAPH,
    DATA, SHAPE, INDEX, COLUMNS, DF, LOC, ILOC, ICAT, IDX, COLS, DS, ROWS
)

from chck import isdf, isds, istup, isdfds
from hasr import make as hmake

# %% ../nbs/10_attr.ipynb 6
from .cons import empty
from .atyp import DataType, GraphType, Shaped
from .grds import isdata, isgraph, isshaped
from .core import make

# %% ../nbs/10_attr.ipynb 9
@make(SHAPE, guard=istup, otype=isshaped, default=tuple())
def getshape(x, default = tuple()) -> tuple | None: ...

# %% ../nbs/10_attr.ipynb 11
@make(DF, guard=isdf, retself=True)
def getdf(x, default = None) -> DataType | None: ...

@make(COLS, otype=isshaped)
def getcols(x) -> DataType | None: ...

@make(COLUMNS, otype=isshaped)
def getcolumns(x) -> DataType | None: ...

# %% ../nbs/10_attr.ipynb 12
@make(IDX)
def getidx(x, default = None) -> DataType | None: ...

@make(INDEX)
def getindex(x, default = None) -> DataType | None: ...

# %% ../nbs/10_attr.ipynb 13
@make(LOC, otype=isdf)
def getloc(x, default = None) -> DataType | None: ...

@make(ILOC, otype=isdf)
def getiloc(x, default = None) -> DataType | None: ...

@make(ICAT, otype=isdf)
def geticat(x, default = None) -> DataType | None: ...

# %% ../nbs/10_attr.ipynb 15
@make(DS, guard=isds, retself=True)
def getds(x, default = None) -> DataType | None: ...

# %% ../nbs/10_attr.ipynb 16
@make(DF, guard=isdf, otype=isdfds, retself=True) 
def getdfds(x, default = None) -> DataType | None: ...

# %% ../nbs/10_attr.ipynb 18
@make(KERNEL, guard=isdata)
def getkernel(x, default = None) -> DataType | None: ...

@make(KERNEL_DEGREE, guard=isdata)
def getkdegree(x, default =  None) -> DataType | None: ...

@make(AFFINITY, guard=isdata)
def getaffinity(x, default =  None) -> DataType | None: ...

@make(DIFF_OP, guard=isdata)
def getdiffop(x, default =  None) -> DataType | None: ...

@make(DATA, guard=isdata, default=empty)
def getdata(x, default =  None) -> DataType | None: ...

@make(GRAPH, guard=isgraph)
def getgraph(p: PHATE, default =  None) -> DataType | None: ...

@make(CLUSTERS, guard=isdata)
def getclusters(x, default =  None) -> DataType | None: ...

@make(EMBEDDING, guard=isdata)
def getembedding(x, default =  None) -> DataType | None: ...

@make(CENTROIDS,guard=isdata)
def getcentroids(x, default =  None) -> DataType | None: ...

@make(DIFF_POTENTIAL, guard=isdata)
def getdiffpot(p: PHATE, default =  None) -> DataType | None: ...
